#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <openssl/md5.h>

int main(int argc, char *argv[])
{
  MD5_CTX context;
  unsigned char buffer[256], digest[MD5_DIGEST_LENGTH];
  int fd, r, i;

  fd = open(argv[1], O_RDONLY);

  MD5_Init(&context);

  while (1) {
    r = read(fd, buffer, sizeof(buffer));
    if (r == 0)
      break;
    MD5_Update(&context, buffer, r);
  }

  close(fd);

  MD5_Final(digest, &context);

  printf("MD5 (%s) = ", argv[1]);
  for (i = 0; i < MD5_DIGEST_LENGTH; i++) {
    printf("%02x", digest[i]);
  }
  printf("\n");

  return 0;
}
